/*
	gݍ݌^, PODk(?)Ē
*/

#ifndef __TTY_FLDATA__
#define __TTY_FLDATA__

#include <cstring>
#include <fstream>
#include <iterator>

namespace tty{
	//ϒl
	//[1byte]n, [1byte]data(0), ... [1byte]data(n - 1)
	//̌`̃f[^ǂݏ
	//n0̏ꍇ̓f[^݂͑Ȃ

	namespace fldata{
		//\̂ɕKvȃoCgT
		template<typename value_type>
		inline int sl(const value_type &v, const int &size = sizeof(value_type)){
			int i;
			for(i = size - 1; i > -1; --i)
				if(reinterpret_cast<const unsigned char*>(&v)[i]) break;
			return i + 2;
		}

		//^
		typedef unsigned char segment_t;
		typedef segment_t *data_t;

		//read
		//[st]	stream
		//[v]	
		//[return]
		//	V[N
		template<typename stream, typename value_type>
		inline int read(stream &st, value_type &v){
			std::memset(reinterpret_cast<void*>(&v), 0, sizeof(value_type));
			segment_t buff;
			st.read(reinterpret_cast<stream::char_type*>(&buff), sizeof(segment_t));
			int i = static_cast<int>(buff);
			if(i)
				st.read(
					reinterpret_cast<stream::char_type*>(&v),
					static_cast<std::streamsize>(i)
				);
			return i + 1;
		}

		//read
		//back_insert_iterator̓ꉻ
		template<typename stream, typename container>
		inline int read(stream &st, std::back_insert_iterator<container> it){
			container::value_type v;
			int r = read(st, v);
			it = v;
			++it;
			return r;
		}

		//read_uni
		template<typename stream, typename container>
		inline int read_uni(stream &st, container &cr){
			segment_t seg;
			st.read(reinterpret_cast<stream::char_type*>(&seg), sizeof(segment_t));
			cr.push_back(seg);
			size_t s = cr.size();
			if(seg){
				cr.resize(s + seg);
				st.read(
					reinterpret_cast<stream::char_type*>(&cr[s]),
					static_cast<std::streamsize>(seg)
				);
			}
			return seg + 1;
		}

		//write
		template<typename stream, typename value_type>
		inline void write(stream &st, const value_type &v, const int &size = sizeof(value_type)){
			int i = sl(v, size);
			segment_t length = static_cast<segment_t>(i - 1);
			st.write(reinterpret_cast<const stream::char_type*>(&length), sizeof(segment_t));
			if(i - 1)
				st.write(
					reinterpret_cast<const stream::char_type*>(&v),
					static_cast<std::streamsize>(i - 1)
				);
		}

		//write
		//data_t̓ꉻ
		template<typename stream>
		inline void write(stream &st, data_t data){
			st.write(reinterpret_cast<const stream::char_type*>(data), sizeof(segment_t));
			if(data[0])
				st.write(
					reinterpret_cast<const stream::char_type*>(&data[1]),
					static_cast<std::streamsize>(data[0])
				);
		}

		//GR[h
		//[a]	ʂ܂|C^
		//[v]	GR[hΏ
		//[size = sizeof(value_type)]
		//		Ώۂ̃TCY
		//[return]
		//		ʃf[^Ŝ̃TCY
		template<typename value_type>
		inline int encode(data_t &a, const value_type &v, const int &size = sizeof(value_type)){
			int l = sl(v, size);
			a = new segment_t[l];
			a[0] = static_cast<segment_t>(l - 1);
			if(l - 1)
				std::memcpy(reinterpret_cast<void*>(&(a[1])), reinterpret_cast<const void*>(&v), l - 1);
			return l;
		}

		//encodeaɃAP[gʂ邪encode_na͂Ȃ
		//slĂꍇsllɂ̒l
		//na͎slll擾
		//[a]	ʂꏊw|C^
		//[v]	ϊl
		//[sll]	sll
		//[size]ϊvf̌^̑傫
		//[return]
		//	fR[h̑傫
		template<typename value_type>
		inline int encode_xna(data_t a, const value_type &v, int sll, const int &size = sizeof(value_type)){
			a[0] = static_cast<segment_t>(sll - 1);
			if(sll - 1)
				std::memcpy(reinterpret_cast<void*>(&(a[1])), reinterpret_cast<const void*>(&v), sll - 1);
			return sll;
		}

		template<typename value_type>
		inline int encode_na(data_t a, const value_type &v, const int &size = sizeof(value_type)){
			return encode_xna(a, v, sl(v, size), size);
		}

		//fR[h
		//[a]	ǂݍރf[^݂̑|C^
		//[t]	ۂɊǂݎ(̃f[^܂ł̋)
		template<typename value_type>
		inline value_type decode(const data_t &a, int &t){
			value_type v = 0;
			if(a[0])
				std::memcpy(reinterpret_cast<void*>(&v), reinterpret_cast<void*>(&(a[1])), a[0]);
			t = static_cast<int>(a[0] + 1);
			return v;
		}
	}
};

#endif // __TTY_FLDATA__
